//*****************************************************************************************
// Truevision - a 3d modeler for gnome and povray
//
// proppanel.cc
//
// Vincent LE PRINCE <vincentleprince@users.sourceforge.net>
// Copyright (C) 2000-2001 Vincent LE PRINCE
// This file is part of the TRUEVISION Package

//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */ 
//*******************************************************************************************
#include "proppanel.h"
#include "objectlist.h"
#include "matlist.h"


//***************************************************
// Constructeur
//***************************************************
PropPanel::PropPanel( app_objs *appref, GtkWidget *box )
{
app_ref = appref;
app_ref->proppanel = this;
OBJLIST_DEF 
TEXLIST_DEF

notebook = gtk_notebook_new();
gtk_widget_set_usize( notebook, 257, -1 );
gtk_notebook_set_scrollable( GTK_NOTEBOOK(notebook), TRUE );
gtk_box_pack_start( GTK_BOX(box), notebook, TRUE, TRUE, 4 );

GtkWidget *pbox = new_page( notebook, _(" Edit ") );
objlist->set_edit_widget( pbox );

pbox = new_page( notebook, _(" Select ") );
objlist->set_select_widget( pbox );

pbox = new_page( notebook, _(" Create ") );
objlist->set_create_widget( pbox );

pbox = new_page( notebook, _(" Materials ") );
texlist->set_select_widget( pbox );
}

//*****************************************************
// New Page
//*****************************************************
GtkWidget *PropPanel::new_page( GtkWidget *notebk, const gchar *titre )
{
GtkWidget *vbox = gtk_vbox_new( FALSE, 0 );
gtk_container_set_border_width( GTK_CONTAINER(vbox), 2 );
GtkWidget *wlab = gtk_label_new( titre );
gtk_notebook_append_page( GTK_NOTEBOOK(notebk), vbox, wlab );
return vbox;
}
